function [q, xIArray] = forwardSphereProjection(X_0,TCam,K,d,r)

nPoints = size(X_0,2);

xIArray = ones(4,nPoints);
for k = 1:nPoints
    xIArray(1:3,k) = singleForwardSphereProjectionUp(X_0(:,k),d,r);
end   
q = K*[eye(3) zeros(3,1)]*inv(TCam)*xIArray;
q = bsxfun(@rdivide,q,q(3,:));
return;