function [L1,L2,F,G,t]= tellerLineExtraction(xi,xiBar)


M = [xiBar;xi]';
[U, tellerS, V] = svd(M);

F = V(:,end-1);
G = V(:,end);

aa = twoLinesSide(F(1:3),F(4:6),F(1:3),F(4:6));
bb = twoLinesSide(F(1:3),F(4:6),G(1:3),G(4:6));
cc = twoLinesSide(G(1:3),G(4:6),G(1:3),G(4:6));

tPlus = (-bb+sqrt(bb^2-aa*cc))/aa;
tMinus = (-bb-sqrt(bb^2-aa*cc))/aa;

sol1 = F*tPlus+G;
L1 = sol1/norm(sol1(1:3));
sol2 = F*tMinus+G;
L2 = sol2/norm(sol2(1:3));    

t = [tPlus tMinus];

